package Spec;

import br.ufpe.abaco.gui.*;
import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ActionInterpreter.*;

import javax.swing.*;

public class ActionConsole {

    static DesktopWindow outputWindow = null;
    static JTextArea output = null;

    static void setContents(String s) {
	if (outputWindow==null || outputWindow.isClosed()) {
	    outputWindow = new DesktopWindow("Action Output",true,true,true,true);
	    output = new JTextArea();
	    outputWindow.getContentPane().add(new JScrollPane(output));
	}

	output.append(s);
	output.setCaretPosition(output.getText().length());
    }

    static void output(Term t) {
	String contents;
	if (t instanceof StringTerm)
	    contents = ((StringTerm)t).getValue();
	else
	    contents = t.toString();
	setContents(contents);
	
    }


    public static void register(CompiledSpecification spec) {


	final Interpreter interp = (Interpreter)spec.getKey("ActionInterpreter");
	interp.insertEvaluator("print _", new br.ufpe.abaco.ActionInterpreter.ActionEvaluator() {
		public RuntimeAction evaluateAction(Term action, RuntimeAction income) throws PerformanceException  {
		    Term t = evaluateYielder(action.getLeaf(0),income);
		    output(t);
		    return new RuntimeAction(null,null);
		}
	    });
	interp.insertEvaluator("println _", new br.ufpe.abaco.ActionInterpreter.ActionEvaluator() {
		public RuntimeAction evaluateAction(Term action, RuntimeAction income) throws PerformanceException  {
		    Term t = evaluateYielder(action.getLeaf(0),income);
		    output(t);
		    setContents("\n");
		    return new RuntimeAction(null,null);
		}
	    });

    }

    public static String[] dependencies() {
	return new String[] { "br.ufpe.abaco.ActionInterpreter.Interpreter" };
    }

}
