package Spec;

import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ParserGen.*;

public class IdentifierImplementation {

    
    public static class IsIdentifier extends SingleTokenProduction {

	IsIdentifier() {
	    setAction(new StringAction() {
		    public Object act(String source) {
			return new IdentifierTerm(source);
		    }
		});
	}

	public boolean test(String source) {
	    if (source.length()==0)
		return false;
	    if (!Character.isLetter(source.charAt(0)))
		return false;
	    for (int c =1 ;c<source.length();c++) {
		if (!Character.isLetterOrDigit(source.charAt(c)))
		    return false;
	    }
	    return true;
	}

	public String toString() {
	    return "IDENTIFIER";
	}
	
    } 

    public static void register(CompiledSpecification spec) {
	
	spec.insertNativeType("Identifier", IdentifierTerm.class, new IsIdentifier());


	spec.insertNativeImplementation("token of _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    
		    if (args[0] instanceof IdentifierTerm)
			return new StringTerm((((IdentifierTerm)args[0]).getValue()));
		    return null;
		}
	    });
	

    }


}
