package Spec;

import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ParserGen.*;

public class NumberImplementation {

    CompiledSpecification spec;

    Term vTrue = null;
    Term vFalse = null;


    private void initializeTerms() {
	vTrue = spec.getOperator("true").apply(new Term[0]);
	vFalse = spec.getOperator("false").apply(new Term[0]);

    }

    
    public static void register(CompiledSpecification spec) {
	new NumberImplementation(spec);
    }
    public NumberImplementation(CompiledSpecification spec) {
	
	this.spec = spec;
	
	SingleTokenProduction single = new Numeral();
	single.setAction(new StringAction() {
		public Object act(String s) {
		    try {
			return new NumeralTerm(Integer.parseInt(s));
		    }
		    catch (Exception ex) { return null; }
		}
	    });

	spec.insertNativeType("number", NumeralTerm.class, single);


	spec.insertNativeImplementation("sum _ _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm && args[1] instanceof NumeralTerm) {
			return new NumeralTerm((((NumeralTerm)args[0]).getValue())+
					       (((NumeralTerm)args[1]).getValue())
					       );
		    }
		    return null;
		}
	    });

	spec.insertNativeImplementation("difference ( _ , _ )", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm && args[1] instanceof NumeralTerm) {
			return new NumeralTerm((((NumeralTerm)args[0]).getValue())-
					       (((NumeralTerm)args[1]).getValue())
					       );
		    }
		    return null;
		}
	    });
	

	spec.insertNativeImplementation("product _ _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm && args[1] instanceof NumeralTerm) {
			return new NumeralTerm((((NumeralTerm)args[0]).getValue())*
					       (((NumeralTerm)args[1]).getValue())
					       );
		    }
		    return null;
		}
	    });

	spec.insertNativeImplementation("_ is lesser than _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm && args[1] instanceof NumeralTerm) {
			if (vTrue==null) initializeTerms();
			if ( (((NumeralTerm)args[0]).getValue())<(((NumeralTerm)args[1]).getValue()) )
			    return vTrue;
			else
			    return vFalse;
		    }
		    return null;
		}
	    });
	
	spec.insertNativeImplementation("_ is greater than _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm && args[1] instanceof NumeralTerm) {
			if (vTrue==null) initializeTerms();
			if ( (((NumeralTerm)args[0]).getValue()) > (((NumeralTerm)args[1]).getValue()) )
			    return vTrue;
			else
			    return vFalse;
		    }
		    return null;
		}
	    });
	
	
	
       	

    }


}
