package Spec;

import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ParserGen.*;

public class StringImplementation {

    
    public static void register(CompiledSpecification spec) {
	
	SingleTokenProduction single = new IsString("INTERNALSTRING");
	single.setAction(new StringAction() {
		public Object act(String s) {
		    return new StringTerm(s.substring(1,s.length()-1));
		}
	    });
	spec.insertNativeType("string", StringTerm.class,single);


	spec.insertNativeImplementation("concatenation _ _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof StringTerm && args[1] instanceof StringTerm) {
			//System.out.println("Concatenando : " + args[0] + " " + args[1]);
			return new StringTerm((((StringTerm)args[0]).getValue())+
					      (((StringTerm)args[1]).getValue())
					      );
		    }
		    return null;
		}
	    });
	

	spec.insertNativeImplementation("value of _", new NativeImplementation() {
		public Term evaluate(Term args[]) {
		    if (args[0] instanceof NumeralTerm) {
		      int val = ((NumeralTerm)args[0]).getValue();
		      String str = String.valueOf(val);
			return new StringTerm(str);
		    }
		    return null;
		}
	    });
	


    }


}
